package IRIS;

import java.util.Collection;

import org.drools.KnowledgeBase;
import org.drools.KnowledgeBaseFactory;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderConfiguration;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.definition.KnowledgePackage;
import org.drools.io.ResourceFactory;
import org.drools.logger.KnowledgeRuntimeLogger;
import org.drools.logger.KnowledgeRuntimeLoggerFactory;
import org.drools.runtime.StatefulKnowledgeSession;


public class RuleRunner {

    public RuleRunner() {
    }

    public void runRules(String[] rules,
                         Object[] facts) throws Exception {
    	System.setProperty("drools.dialect.java.compiler", "JANINO");
    	System.setProperty("drools.dialect.java.compiler.lnglevel", "1.5");
        KnowledgeBase kbase = KnowledgeBaseFactory.newKnowledgeBase();
        KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();
        //KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder(kbase);
        
        
        for ( int i = 0; i < rules.length; i++ ) {
            String ruleFile = rules[i];
            //System.out.println( "Loading file: " + ruleFile );
            kbuilder.add( ResourceFactory.newClassPathResource(ruleFile,RuleRunner.class ),
                          ResourceType.DRL );
        }
        
        
        Collection<KnowledgePackage> pkgs = kbuilder.getKnowledgePackages();
        kbase.addKnowledgePackages( pkgs );
  
        StatefulKnowledgeSession ksession = kbase.newStatefulKnowledgeSession();
      
        for ( int i = 0; i < facts.length; i++ ) {
            Object fact = facts[i];
            //System.out.println( "Inserting fact: " + fact );
            ksession.insert( fact );
        }

        ksession.fireAllRules();
        
    }
    
    public void runRules(String ruleFile,InfinityMessage fact) throws Exception {
    	
    	//System.setProperty("drools.compiler", "JANINO");
    	System.setProperty("drools.dialect.java.compiler", "JANINO");
    	System.setProperty("drools.dialect.java.compiler.lnglevel", "1.5");
    	//System.out.println("drools.compiler: "+ System.getProperty("drools.compiler"));
        KnowledgeBuilderConfiguration kbuilderconfiguration  = KnowledgeBuilderFactory.newKnowledgeBuilderConfiguration();
        //kbuilderconfiguration.setProperty("drools.dialect.java.compiler", "ECLIPSE" );
        //kbuilderconfiguration.setProperty(arg0, arg1);
        
        final KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();
        
        kbuilder.add( ResourceFactory.newClassPathResource( ruleFile),
                              ResourceType.DRL );
        
        final KnowledgeBase kbase = KnowledgeBaseFactory.newKnowledgeBase();
        kbase.addKnowledgePackages( kbuilder.getKnowledgePackages() );

        final StatefulKnowledgeSession ksession = kbase.newStatefulKnowledgeSession();

        KnowledgeRuntimeLogger klogger = KnowledgeRuntimeLoggerFactory.newFileLogger(ksession, "C:/temp/Log/BRETest");

        ksession.insert( fact );
        
        ksession.fireAllRules();

        klogger.close();

        ksession.dispose();
        
    }

}
